<template>
  <div class="row top-position justify-content-center">
    <div class="col-md-8">
      <div class="card card-default">
        <div class="card-header">
          <div class="row">
            <div class="col-2">
              <button v-b-modal.create-user class="btn btn-add">create new</button>
            </div>
            <div class="col-10">
              <b-pagination
                v-model="currentPage"
                :per-page="perPage"
                aria-controls="my-table"
                align="right"
                pills
                :total-rows="rows"
                size="md"
              ></b-pagination>
            </div>
          </div>
        </div>
        <div class="card-body scrollbar overflow-hompage">
          <b-table
            id="my-table"
            :items="getUser"
            :per-page="perPage"
            :current-page="currentPage"
            :fields="fields"
            small
            hover
          >
            <template v-slot:cell(actions)="row">
              <b-button size="sm" @click="viewUser(row.item.id)" class="btn btn-manage">
                <i class="fa fa-user" style="font-size:0.9rem;"></i> visit
              </b-button>
              <b-button size="sm" @click="getEditUser(row.item.id)" class="btn btn-edit">
                <i class="fa fa-edit" style="font-size:0.9rem;"></i> edit
              </b-button>
              <b-button
                size="sm"
                @click="getDeleteUser(row.item.id)"
                v-b-modal.delete-user
                class="btn btn-delete"
              >
                <i class="fa fa-trash-o" style="font-size:0.9rem;"></i> delete
              </b-button>
            </template>
          </b-table>
        </div>
      </div>
    </div>
<!-- create user -->
    <b-modal
      id="create-user"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Create New Employee</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input type="text" v-model="username" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Username</label>
                <div class="row absolute">
                  <h6 v-if="username === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Username is required
                  </h6>
                  <h6
                    v-if="(username.length > 0) && (username.length < 6)"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" /> Username must have at least 6 characters
                  </h6>
                  <h6 v-if="username.length > 5" class="t-validate-div t-color-green col-12 right">
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group">
                <input type="text" v-model="email" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Email</label>
                <div class="row absolute">
                  <h6 v-if="email === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Email is required
                  </h6>
                  <h6
                    v-if="(email !=='') && (!reg.test(email))"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" /> Please Enter Correct Email
                  </h6>
                  <h6
                    v-if="(email !=='') && (reg.test(email))"
                    class="t-validate-div t-color-green col-12 right"
                  >
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group">
                <input type="password" v-model="password" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Password</label>
                <div class="row absolute">
                  <h6 v-if="password === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Password is required
                  </h6>
                  <h6
                    v-if="(password.length > 0) && (password.length < 6)"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" />Password must have at least 6 characters
                  </h6>
                  <h6
                    v-if="(password.length > 5)"
                    class="t-validate-div t-color-green col-12 right"
                  >
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="group">
                <input type="password" v-model="conpassword" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Confirm Password</label>
                <div class="row absolute">
                  <h6 v-if="conpassword === ''" class="t-validate-div t-color-red col-12 right">
                    <i class="fa fa-exclamation-circle" /> Confirm password is required
                  </h6>
                  <h6
                    v-if="(conpassword.length > 0) && (conpassword.length < 6)"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" />Confirm password must have at least 6 characters
                  </h6>
                  <h6
                    v-if="(password !== conpassword) && (conpassword !== '')"
                    class="t-validate-div t-color-red col-12 right"
                  >
                    <i class="fa fa-times-circle" />Your password incorrect to matching
                  </h6>
                  <h6
                    v-if="(password === conpassword) && (conpassword !== '') && (conpassword.length > 5)"
                    class="t-validate-div t-color-green col-12 right"
                  >
                    <i class="fa fa-check-circle" /> Correct
                  </h6>
                </div>
              </div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button
          size="sm"
          v-on:click="createUser"
          class="btn btn-delete position-send-in-modal"
          @click="hide()"
        >
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- edit user -->
    <b-modal ref="edit-user" size="lg" hide-footer hide-header style="position: absolute;">
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Edit Employee's Information</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div role="tablist">
                <b-card no-body class="mb-1">
                  <b-card-header role="tab" style="padding: 0">
                    <tag-member
                      class="btn btn-delete"
                      style="width:-webkit-fill-available;"
                      block
                      href="#"
                      v-b-toggle.accordion-1
                      variant="info"
                    >User</tag-member>
                  </b-card-header>
                  <b-collapse id="accordion-1" accordion="my-accordion" role="tabpanel">
                    <b-card-body>
                      <div class="group">
                        <input type="text" v-model="editUser.username" required="required" />
                        <span class="highlight"></span>
                        <span class="bar"></span>
                        <label>Username</label>
                        <h6 v-if="(editUser.username === '')" class="t-validate t-color-red">
                          <i class="fa fa-exclamation-circle" /> Username is required
                        </h6>
                      </div>
                    </b-card-body>
                  </b-collapse>
                </b-card>
                <b-card no-body class="mb-1">
                  <b-card-header role="tab" style="padding: 0">
                    <tag-member
                      class="btn btn-delete"
                      style="width:-webkit-fill-available;"
                      block
                      href="#"
                      v-b-toggle.accordion-2
                      variant="info"
                    >Profile</tag-member>
                  </b-card-header>
                  <b-collapse id="accordion-2" accordion="my-accordion" role="tabpanel">
                    <b-card-body>
                      <div class="col-12 row scrollbar overflow-sub-contain">
                        <div class="col-md-6 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.firstName" />
                            <span class="bar"></span>
                            <label>First Name</label>
                            <h6
                              v-if="(editProfile.firstName === '')"
                              class="t-validate t-color-red"
                            >
                              <i class="fa fa-exclamation-circle" /> First name is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-6 inp-space">
                          <div class="group">
                            <input type="text" v-model="editProfile.surName" />
                            <span class="bar"></span>
                            <label>Surname</label>
                          </div>
                        </div>
                        <div class="col-md-6 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.lastName" />
                            <span class="bar"></span>
                            <label>Last Name</label>
                            <h6 v-if="(editProfile.lastName === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> Last Name is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-6 inp-space">
                          <div class="group">
                            <input type="date" required="required" v-model="editProfile.DoB" />
                            <span class="bar" placeholder="false"></span>
                            <label>Date of Birth</label>
                            <h6 v-if="(editProfile.DoB === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> Date of birth is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-9 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.address" />
                            <span class="bar"></span>
                            <label>Address</label>
                            <h6 v-if="(editProfile.address === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> Address is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-3 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.road" />
                            <span class="bar"></span>
                            <label>Road</label>
                            <h6 v-if="(editProfile.road === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> Road is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-5 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.district" />
                            <span class="bar"></span>
                            <label>District</label>
                            <h6 v-if="(editProfile.district === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> District is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-5 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.province" />
                            <span class="bar"></span>
                            <label>Province</label>
                            <h6 v-if="(editProfile.province === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> Province is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-2 inp-space">
                          <div class="group">
                            <input type="text" required="required" v-model="editProfile.zip" />
                            <span class="bar"></span>
                            <label>ZIP</label>
                            <h6 v-if="(editProfile.zip === '')" class="t-validate t-color-red">
                              <i class="fa fa-exclamation-circle" /> ZIP is required
                            </h6>
                          </div>
                        </div>
                        <div class="col-md-12 inp-space">
                          <div class="group">
                            <input
                              type="text"
                              required="required"
                              v-model="editProfile.phoneNumber"
                            />
                            <span class="bar"></span>
                            <label>Phone Number</label>
                            <h6
                              v-if="(editProfile.phoneNumber === '')"
                              class="t-validate t-color-red"
                            >
                              <i class="fa fa-exclamation-circle" /> Phone number is required
                            </h6>
                          </div>
                        </div>
                      </div>
                    </b-card-body>
                  </b-collapse>
                </b-card>
                <b-card no-body class="mb-1">
                  <b-card-header role="tab" style="padding: 0">
                    <tag-member
                      class="btn btn-delete"
                      style="width:-webkit-fill-available;"
                      block
                      href="#"
                      v-b-toggle.accordion-3
                      variant="info"
                    >Password</tag-member>
                  </b-card-header>
                  <b-collapse id="accordion-3" accordion="my-accordion" role="tabpanel">
                    <b-card-body>
                      <div class="group pass_show">
                        <input type="password" v-model="password" required="required" />
                        <span class="highlight"></span>
                        <span class="bar"></span>
                        <div class="row absolute">
                          <h6
                            v-if="password === ''"
                            class="t-validate-div t-color-yellow col-12 right"
                          >
                            <i class="fa fa-exclamation-circle" /> If need to change password
                          </h6>
                          <h6
                            v-if="(password.length > 0) && (password.length < 6)"
                            class="t-validate-div t-color-red col-12 right"
                          >
                            <i class="fa fa-times-circle" />Password must have at least 6 characters
                          </h6>
                          <h6
                            v-if="(password.length > 5)"
                            class="t-validate-div t-color-green col-12 right"
                          >
                            <i class="fa fa-check-circle" /> Correct
                          </h6>
                        </div>
                        <label>New Password</label>
                      </div>
                      <div class="group pass_show">
                        <input type="password" v-model="conpassword" required="required" />
                        <span class="highlight"></span>
                        <span class="bar"></span>
                        <label>Confirm New Password</label>
                        <div class="row absolute">
                          <h6
                            v-if="(password !== '') && (conpassword.length < 1)"
                            class="t-validate-div t-color-red col-12 right"
                          >
                            <i class="fa fa-exclamation-circle" /> Confirm password is required
                          </h6>
                          <h6
                            v-if="(conpassword.length > 0) && (conpassword.length < 6)"
                            class="t-validate-div t-color-red col-12 right"
                          >
                            <i class="fa fa-times-circle" />Confirm password must have at least 6 characters
                          </h6>
                          <h6
                            v-if="(password !== conpassword) && (conpassword.length > 0)"
                            class="t-validate-div t-color-red col-12 right"
                          >
                            <i class="fa fa-times-circle" />Your password incorrect to matching
                          </h6>
                          <h6
                            v-if="(password === conpassword) && (conpassword !== '') && (conpassword.length > 5)"
                            class="t-validate-div t-color-green col-12 right"
                          >
                            <i class="fa fa-check-circle" /> Correct
                          </h6>
                        </div>
                      </div>
                    </b-card-body>
                  </b-collapse>
                </b-card>
                <b-card no-body class="mb-1">
                  <b-card-header role="tab" style="padding: 0">
                    <tag-member
                      class="btn btn-delete"
                      style="width:-webkit-fill-available;"
                      block
                      href="#"
                      v-b-toggle.accordion-4
                      variant="info"
                    >Role</tag-member>
                  </b-card-header>
                  <b-collapse id="accordion-4" accordion="my-accordion" role="tabpanel">
                    <b-card-body>
                      <p class="t-color-soft-gray" style="text-align-last: center;">
                        {{editUser.username}}'role is {{getCurrentRole}}
                        <i class="fa fa-arrow-right t-color-red" />
                        {{editUser.role}}
                      </p>
                      <b-button class="btn btn-add" @click="getRoleData">Change now</b-button>
                    </b-card-body>
                  </b-collapse>
                </b-card>
              </div>
            </div>
          </div>
          <button
            size="sm"
            class="btn btn-delete position-send-in-modal"
            v-on:click="updateUserInfo"
          >
            <i class="fa fa-check" style="font-size:1.5rem;"></i>
          </button>
        </div>
      </form>
    </b-modal>
<!-- visit user -->
    <b-modal
      ref="modal-view"
      id="view-project"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <h2 class="t-color-red" align="center">User profile</h2>
      <hr />
      <div class="space-1" />
      <h4 class="t-color-red" align="center">Visit to {{getViewuser.username}}'s profile</h4>
      <div class="space-1" />
      <h6 class="t-color-soft-gray" align="center">Please click button below.</h6>
      <hr />
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">cancel</button>
      <router-link
        :to="'/profile-view/' + getViewuser.id"
        size="sm"
        v-on:click="deleteProject"
        class="btn btn-delete t-uppercase f-right"
        @click="hide()"
      >Visit</router-link>
    </b-modal>
<!-- delete user -->
    <b-modal
      ref="modal"
      id="delete-user"
      size="lg"
      hide-footer
      hide-header
      style="position: absolute;"
      v-slot:default="{ hide }"
    >
      <h2 class="t-color-red" align="center">Delete User</h2>
      <hr />
      <div class="space-1" />
      <h4 class="t-color-red" align="center">Are You sure?</h4>
      <div class="space-1" />
      <h6 class="t-color-soft-gray" align="center">Do you really want to delete this user.</h6>
      <hr />
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">cancel</button>
      <button
        size="sm"
        v-on:click="deleteUser"
        class="btn btn-delete t-uppercase f-right"
        @click="hide()"
      >confirm</button>
    </b-modal>
<!-- alert -->
    <b-alert
      :show="success"
      variant="success"
      @dismissed="successCountDown=0"
      @dismiss-count-down="SuccessCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-check-circle"/> {{massage}}
    </b-alert>
    <b-alert
      :show="error"
      variant="danger"
      @dismissed="errorCountDown=0"
      @dismiss-count-down="ErrorCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-exclamation-circle"/> {{massage}}
    </b-alert>
  </div>
</template>
<script>
export default {
  mounted () {
    if (!this.$cookie.get('token')) {
      this.$router.push('/signin')
    }
    if (this.$cookie.get('role') !== 'Admin') {
      this.$router.push('/ProjectBlockList')
    }
    this.getData()
    this.getRoleData()
  },
  methods: {
    getData () {
      this.axios.get('api/userList').then(response => {
        this.getUser = response.data
      })
    },
    createUser: function (e) {
      e.preventDefault()
      this.axios
        .post('http://127.0.0.1:8000/api/createUser', {
          username: this.username,
          email: this.email,
          password: this.password,
          passwordConfirmation: this.conpassword
        })
        .then(response => {
          console.log(response)
          this.showAlertCreateUser()
        })
        .catch(error => {
          console.log(error)
          this.showAlertErrorCreateUser()
        })
      this.getData()
    },
    viewUser (info) {
      this.editUser = ''
      this.editProfile = ''
      this.modalViewUserId = JSON.stringify(info, null, 2)
      this.axios.get('/api/showUser/' + this.modalViewUserId).then(response => {
        this.getViewuser = response.data
        this.$refs['modal-view'].show()
      })
    },
    getEditUser (userId) {
      this.password = ''
      this.conpassword = ''
      this.editUser = ''
      this.editProfile = ''
      this.modalEdit.userId = JSON.stringify(userId, null, 2)
      this.getUserInfo()
      this.getProfileInfo()
      this.$refs['edit-user'].show()
    },
    getUserInfo () {
      this.axios.get('api/editUser/' + this.modalEdit.userId).then(response => {
        this.editUser = response.data
        this.getCurrentRole = this.editUser.role
      })
    },
    getProfileInfo () {
      this.axios
        .get('api/editProfile/' + this.modalEdit.userId)
        .then(response => {
          this.editProfile = response.data
        })
    },
    getRoleData () {
      if (this.role === 'User') {
        this.role = 'Admin'
        this.editUser.role = 'Admin'
      } else {
        this.role = 'User'
        this.editUser.role = 'User'
      }
    },
    updateUserInfo: function (e) {
      e.preventDefault()
      this.axios
        .put('/api/changePassword/' + this.modalEdit.userId, {
          password: this.password,
          passwordConfirmation: this.password
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.axios
        .put('/api/updateProfile/' + this.modalEdit.userId, {
          firstName: this.editProfile.firstName,
          surName: this.editProfile.surName,
          lastName: this.editProfile.lastName,
          address: this.editProfile.address,
          road: this.editProfile.road,
          district: this.editProfile.district,
          province: this.editProfile.province,
          zip: this.editProfile.zip,
          phoneNumber: this.editProfile.phoneNumber,
          DoB: this.editProfile.DoB
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.axios
        .put('/api/updateUser/' + this.modalEdit.userId, {
          username: this.editUser.username
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.axios
        .put('/api/changeRole/' + this.modalEdit.userId, {
          role: this.editUser.role
        })
        .then(function (response) {
          console.log(response)
        })
        .catch(function (error) {
          console.log(error)
        })
      this.getData()
      this.showAlertUpdateUser()
      this.$refs['edit-user'].hide()
    },
    getDeleteUser (id) {
      this.modalEdit.userId = JSON.stringify(id, null, 2)
    },
    deleteUser: function (e) {
      e.preventDefault()
      this.axios
        .put('/api/destroyUser/' + this.modalEdit.userId)
        .then(response => {
          console.log(response)
          this.showAlertDestroyUser()
        })
        .catch(function (error) {
          console.log(error)
        })
      this.getData()
    },
    SuccessCountDownChanged (dismissCountDown) {
      this.success = dismissCountDown
    },
    ErrorCountDownChanged (dismissCountDown) {
      this.error = dismissCountDown
    },
    showAlertCreateUser () {
      this.massage = ''
      this.massage = 'Create a new user completed.'
      this.success = this.dismissSecs
    },
    showAlertDestroyUser () {
      this.massage = ''
      this.massage = 'Destroy a user completed.'
      this.success = this.dismissSecs
    },
    showAlertUpdateUser () {
      this.massage = ''
      this.massage = 'Update a user completed.'
      this.success = this.dismissSecs
    },
    showAlertErrorCreateUser () {
      this.massage = ''
      this.massage = 'Somthing wrong, Please try again.'
      this.error = this.dismissSecs
    }
  },
  data () {
    return {
      perPage: 25,
      currentPage: 1,
      getUser: [],
      pageName: 'Employee List',
      fields: [
        { key: 'id', sortable: true },
        { key: 'username', sortable: true },
        { key: 'email', sortable: true },
        { key: 'actions', label: 'Actions' }
      ],
      username: '',
      email: '',
      password: '',
      conpassword: '',
      modalViewUserId: '',
      getViewuser: '',
      modalEdit: [
        {
          userId: ''
        }
      ],
      checkEditError: [],
      editUser: [],
      editProfile: [],
      getCurrentRole: '',
      massage: '',
      dismissSecs: 3,
      dismissCountDown: 0,
      success: 0,
      error: 0,
      reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/
    }
  },
  computed: {
    rows () {
      return this.getUser.length
    }
  }
}
</script>
